/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_FetalLongBoneAnatomicSites;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_FetalLongBoneAnatomicSites;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumAnatomicSNOMEDMap;

/**
 * This class represents FetalLongBoneAnatomicSites CID12021
 */
public class FetalLongBoneAnatomicSites_CID12021 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new FetalLongBoneAnatomicSites_CID12021 Template 
	 */
	public FetalLongBoneAnatomicSites_CID12021()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumFetalLongBoneAnatomicSites Object of EnumCM_FetalLongBoneAnatomicSites represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_FetalLongBoneAnatomicSites enumFetalLongBoneAnatomicSites)
	{
		switch(enumFetalLongBoneAnatomicSites) 
		{
		case CLAVICLE: this.strCodeValue =EnumCV_FetalLongBoneAnatomicSites.CLAVICLE_T_12310.getValue(); break;
		case FEMUR: this.strCodeValue =EnumCV_FetalLongBoneAnatomicSites.FEMUR_T_12710.getValue(); break;
		case FIBULA: this.strCodeValue =EnumCV_FetalLongBoneAnatomicSites.FIBULA_T_12750.getValue(); break;
		case RADIUS: this.strCodeValue =EnumCV_FetalLongBoneAnatomicSites.RADIUS_T_12750.getValue(); break;
		case TIBIA: this.strCodeValue =EnumCV_FetalLongBoneAnatomicSites.TIBIA_T_12740.getValue(); break;
		case ULNA: this.strCodeValue =EnumCV_FetalLongBoneAnatomicSites.ULNA_T_12430.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumFetalLongBoneAnatomicSites Object of EnumCM_FetalLongBoneAnatomicSites represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_FetalLongBoneAnatomicSites enumFetalLongBoneAnatomicSites)
	{
		switch(enumFetalLongBoneAnatomicSites)
		{
		case CLAVICLE : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.CLAVICLE.getSNOMEDCTID(); break;
		case FEMUR : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.FEMUR.getSNOMEDCTID(); break;
		case FIBULA : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.FIBULA.getSNOMEDCTID(); break;
		case RADIUS : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.RADIUS.getSNOMEDCTID(); break;
		case TIBIA : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.TIBIA.getSNOMEDCTID(); break;
		case ULNA : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.ULNA.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for FetalLongBoneAnatomicSites
	 * @param enumFetalLongBoneAnatomicSites Object of EnumCM_FetalLongBoneAnatomicSites.
	 */
	public void setFetalLongBoneAnatomicSites(EnumCM_FetalLongBoneAnatomicSites enumFetalLongBoneAnatomicSites)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumFetalLongBoneAnatomicSites.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumFetalLongBoneAnatomicSites);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumFetalLongBoneAnatomicSites);
	}
}
